题目链接:
https://codeforces.com/gym/101933/problem/E
题目大意
我方有
n
n
n个士兵,对方有
m
m
m个士兵,每个士兵有对应的血量,血量
x
x
x为
0
0
0时士兵消失。现在轮到我方进行攻击,共攻击
d
d
d次,每次攻击会等概率选择场上还活着的士兵减少其一滴血,问
d
d
d次攻击后地方士兵全部死亡的概率。
1
≤
n
,
m
≤
5
1\leq n,m \leq5
1≤n,m≤5 ,
1
≤
x
≤
6
1\leq x \leq 6
1≤x≤6 ,
1
≤
d
≤
100
1 \leq d \leq 100
1≤d≤100
题解思路
这道题暴力搜索状态太多肯定做不了,考虑状态压缩记录状态的搜索。
一个士兵只有他的血量是对状态的有效信息,在存的时候用
a
[
0
/
1
]
[
x
]
a[0/1][x]
a[0/1][x]表示我/对方血量
x
x
x的士兵的数量
这样压缩成一个
12
12
12位的十进制数,每一位表示对应血量的士兵的个数,就可以唯一表示状态了。
用
d
p
[
s
t
a
t
u
s
]
dp[status]
dp[status]表示当前状态获胜的概率,因为每次固定掉一滴血,到达这个状态的步数是一定的,不需要另开一维记录步数。
在判断对方是否全部死光的时候,可以将状态表示为高6位为对方,低6位为己方,一旦高6位全部为0
(
n
u
m
<
1000000
)
(num<1000000)
(num<1000000)就表示对方死光了。
假设
i
i
i血量有士兵,对这个士兵造成伤害就是
i
i
i血量的士兵少了一个,
i
−
1
i-1
i−1血量的士兵多了一个。在搜索完这一状态再把血量加回去回溯。
在搜索的时候统计答案。每次对答案的贡献就是 当前血量可供选择的数量*概率/场上士兵数
#include <bits/stdc++.h>
using namespace std;
#define IOS ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);
#define ll long long
//#define int ll
#define debug cout<<"fuck"<<endl;
#define pb push_back
#define endl '\n'
#define fi first
#define se second
#define db double
#define pii pair<int,int>
#define mp make_pair
const int mod=(int)1e9+7;
const int maxn=(int)1e5+5;
int add(int a, int b) {if((a += b) >= mod) a -= mod; return a < 0 ? a + mod : a;}
int mul(int a, int b) {return 1ll * a * b % mod;}
int n,m;
int d;
int a[2][10];
unordered_map<ll,db>ma;
ll f()
{
ll s=0;
for(int i=1;i<=6;i++)
{
s*=10;
s+=a[1][i];
}
for(int i=1;i<=6;i++)
{
s*=10;
s+=a[0][i];
}
return s;
}
int c()
{
int ccnt=0;
for(int i=1;i<=6;i++)
{
ccnt+=(a[0][i]+a[1][i]);
}
return ccnt;
}
double dfs(int lef,ll now)
{
if(ma.count(now))return ma[now];
if(now<1000000)return 1;
if(lef==0)return 0;
int cnt=c();
db res=0;
for(int i=0;i<=1;i++)
{
for(int j=1;j<=6;j++)
{
if(a[i][j])
{
a[i][j]--;a[i][j-1]++;
ll nxt=f();
db tmp=dfs(lef-1,nxt);
ma[nxt]=tmp;
a[i][j]++;a[i][j-1]--;
res+=1.0*tmp/cnt*a[i][j];
}
}
}
return res;
}
int main()
{
IOS
cin>>n>>m>>d;
int x;
for(int i=1;i<=n;i++)
{
cin>>x;
a[0][x]++;
}
for(int i=1;i<=m;i++)
{
cin>>x;
a[1][x]++;
}
ll sta=f();
db res=dfs(d,sta);
cout<<fixed<<setprecision(10)<<res<<endl;
return 0;
}
pps:
在交代码的时候出现了一点状况,本地和交上去的代码运行结果不一样。
这个地方需要注意的是不能直接赋值成
m
a
[
n
x
t
]
=
d
f
s
(
.
.
.
)
ma[nxt]=dfs(...)
ma[nxt]=dfs(...)的形式,cf的实现机制是先会给
m
a
[
n
x
t
]
ma[nxt]
ma[nxt]赋成0,然后再执行dfs。。后来他就会直接
c
o
u
n
t
count
count成有数的。。。非常诡异,以后写搜索的时候需要注意一下。。